package org.bukkit.craftbukkit.v1_7_R1;

import java.util.Date;
import net.minecraft.server.v1_7_R1.BanList;

public final class CraftBanEntry implements org.bukkit.BanEntry
{
  private final BanList list;
  private final String name;
  private Date created;
  private String source;
  private Date expiration;
  private String reason;
  
  public CraftBanEntry(net.minecraft.server.v1_7_R1.BanEntry entry, BanList list)
  {
    this.list = list;
    name = entry.getName();
    created = (entry.getCreated() != null ? new Date(entry.getCreated().getTime()) : null);
    source = entry.getSource();
    expiration = (entry.getExpires() != null ? new Date(entry.getExpires().getTime()) : null);
    reason = entry.getReason();
  }
  
  public String getTarget()
  {
    return name;
  }
  
  public Date getCreated()
  {
    return created == null ? null : (Date)created.clone();
  }
  
  public void setCreated(Date created)
  {
    this.created = created;
  }
  
  public String getSource()
  {
    return source;
  }
  
  public void setSource(String source)
  {
    this.source = source;
  }
  
  public Date getExpiration()
  {
    return expiration == null ? null : (Date)expiration.clone();
  }
  
  public void setExpiration(Date expiration)
  {
    if ((expiration != null) && (expiration.getTime() == new Date(0, 0, 0, 0, 0, 0).getTime())) {
      expiration = null;
    }
    
    this.expiration = expiration;
  }
  
  public String getReason()
  {
    return reason;
  }
  
  public void setReason(String reason)
  {
    this.reason = reason;
  }
  
  public void save()
  {
    net.minecraft.server.v1_7_R1.BanEntry entry = new net.minecraft.server.v1_7_R1.BanEntry(name);
    entry.setCreated(created);
    entry.setSource(source);
    entry.setExpires(expiration);
    entry.setReason(reason);
    
    list.add(entry);
    list.save();
  }
}
