package net.mc_pandacraft.java.plugin.pandacraftutils.data_model;

import java.sql.ResultSet;
import java.sql.SQLException;

public class MPWebSessionTable extends SQLTable<MPWebSessionElement> {

	public MPWebSessionTable() throws SQLException {
		super("pandacraft_mp_web_session");
	}

	@Override
	protected String createTableParameters() {
		return "id INT AUTO_INCREMENT PRIMARY KEY,"
				+ "playerName VARCHAR(16) NOT NULL,"
				+ "lastWebActivity BIGINT NOT NULL,"
				+ "isInGameOnline TINYINT NOT NULL,"
				+ "playerDisplayName VARCHAR(255) NOT NULL";
	}

	@Override
	protected MPWebSessionElement getElementInstance(ResultSet sqlResult)
			throws SQLException {
		return new MPWebSessionElement(
				sqlResult.getInt("id"),
				sqlResult.getString("playerName"),
				sqlResult.getLong("lastWebActivity"),
				sqlResult.getBoolean("isInGameOnline"),
				sqlResult.getString("playerDisplayName"));
	}

}
