package net.mc_pandacraft.java.plugin.pandacraftutils.data_model;

import org.apache.commons.lang.NullArgumentException;
import org.bukkit.Bukkit;
import org.bukkit.Location;

public class StaffTicketElement extends SQLElement {
	

	private String playerName;
	private String message;
	private long creationTime;
	private String staffPlayer = null;
	private String locWorld;
	private double locX;
	private double locY;
	private double locZ;

	
	public StaffTicketElement(String pName, String m, long creaTime, Location loc) {
		super("pandacraft_staff_ticket");
		setPlayerName(pName);
		setMessage(m);
		setCreationTime(creaTime);
		setLocation(loc);
		
	}
	protected StaffTicketElement(int id, String pName, String m, long creaTime, String locW, double x, double y, double z) {
		super("pandacraft_staff_ticket", id);
		setPlayerName(pName);
		setMessage(m);
		setCreationTime(creaTime);
		locWorld = locW;
		locX = x;
		locY = y;
		locZ = z;
	}
	

	@Override
	protected String[] getValues() {
		return new String[] {
				playerName,
				message,
				Long.toString(creationTime),
				staffPlayer,
				locWorld,
				Double.toString(locX),
				Double.toString(locY),
				Double.toString(locZ)
		};
	}

	@Override
	protected String[] getFieldsName() {
		return new String[] {
				"playerName",
				"message",
				"creationTime",
				"staffPlayer",
				"locWorld",
				"locX",
				"locY",
				"locZ"
		};
	}
	public String getPlayerName() {
		return playerName;
	}
	public void setPlayerName(String playerName) {
		if (playerName == null) throw new NullArgumentException("playerName");
		this.playerName = playerName;
	}
	public String getMessage() {
		return message;
	}
	public void setMessage(String message) {
		if (message == null) throw new NullArgumentException("message");
		this.message = message;
	}
	public long getCreationTime() {
		return creationTime;
	}
	public void setCreationTime(long creationTime) {
		this.creationTime = creationTime;
	}
	public String getStaffPlayer() {
		return staffPlayer;
	}
	public void setStaffPlayer(String staffPlayer) {
		this.staffPlayer = staffPlayer;
	}
	public Location getLocation() {
		return new Location(Bukkit.getWorld(locWorld), locX, locY, locZ);
	}
	public void setLocation(Location loc) {
		if (loc == null) throw new NullArgumentException("loc");
		locWorld = loc.getWorld().getName();
		locX = loc.getX();
		locY = loc.getY();
		locZ = loc.getZ();
	}

}
